clear all;

for num_sequences=1:32

seq_name = sprintf('seq_optdir_%d.txt',num_sequences);

header{1} = '#';
header{2} = '# Description: $description';
header{3} = '# Author: Giulio Gaio';
header{4} = '# Date: 2020/12/22';
header{5} = '#';
header{6} = sprintf('# This sequence executes direction optimization looking %d sensors',num_sequences);
header{7} = '#';

start_step = 1;
error_step = 15 + num_sequences;
correction_step = 9;

cnt = 0;
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;(write(this/SleepCnt) = 0) &&  (write(this/Direction) = 0) &&  (write(this/CorrectionVal) = 0) && goto(%d);Resetting variables;Error resetting variables;-1',cnt,cnt+1);

% sleep
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;sleep($sleep_monitor) && (write(this/SleepCnt) = (read(this/SleepCnt) + 1)) && (read(this/SleepCnt) >= read(this/MaxSleepCnt)) ? goto(%d) : goto(%d);Sleeping;Error sleeping;-1',cnt,cnt+1,cnt);

% start condition
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;(($condition_run) && ($condition_corr)) ? (write(this/ActuatorStartValue) = read($devactuator_rr_attr)) && (write(this/RunErrorFlag) = 0) && goto(%d) : (write(this/RunErrorFlag) = 1) && (write(this/CorrectionErrorFlag) = 0) && goto(%d);Evaluating run condition;Error evaluating run condition;-1;tangoerror=goto(%d)', cnt, cnt+1, start_step, error_step);


% positive kick
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;(write(this/SleepCnt) = 0) && (read(this/RandomMode) == 1) ? (write($devactuator_w_attr) = (read(this/ActuatorStartValue) + (read(this/KickVal) * $random))) && goto(%d) :  (write($devactuator_w_attr) = (read(this/ActuatorStartValue) + read(this/KickVal))) && goto(%d);Positive excitation;Error executing positive excitation;-1;tangoerror=goto(%d)',cnt,cnt+1,cnt+1,error_step);

% sleep
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;sleep($sleep_monitor) && (write(this/SleepCnt) = (read(this/SleepCnt) + 1)) && (read(this/SleepCnt) >= read(this/MaxSleepCnt)) ? goto(%d) : goto(%d);Sleeping;Error sleeping;-1',cnt,cnt+1,cnt);

% negative kick
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;(write(this/SleepCnt) = 0) && (read(this/RandomMode) == 1) ? (write($devactuator_w_attr) = (read(this/ActuatorStartValue) - (read(this/KickVal) * $random))) && goto(%d) : (write($devactuator_w_attr) = (read(this/ActuatorStartValue) + read(this/KickVal))) && goto(%d);Negative excitation;Error executing negative excitation;-1;tangoerror=goto(%d)',cnt,cnt+1,cnt+1,error_step);

% sleep
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;sleep($sleep_monitor) && (write(this/SleepCnt) = (read(this/SleepCnt) + 1)) && (read(this/SleepCnt) >= read(this/MaxSleepCnt)) ? goto(%d) : goto(%d);Sleeping;Error sleeping;-1',cnt,cnt+1,cnt);


% set starting value
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;(write($devactuator_w_attr) = read(this/ActuatorStartValue)) && (write(this/TangoErrorFlag) = 0) && goto(%d);Initializing $devactuator_attr;Error initializing $devactuator_attr;-1;tangoerror=goto(%d)',cnt,cnt+1,error_step);

% resetting timing counter
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;(write(this/SleepCnt) = 0) && goto(%d);Resetting variables;Error resetting variables;-1',cnt,cnt+1);

% sleep
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;sleep($sleep_monitor) && (write(this/SleepCnt) = (read(this/SleepCnt) + 1)) && (read(this/SleepCnt) >= read(this/MaxSleepCnt)) ? goto(%d) : goto(%d);Sleeping;Error sleeping;-1',cnt,cnt+1,cnt);

% check run condition and correction condition
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;(($condition_run) && ($condition_corr)) ? (write(this/CorrectionErrorFlag) = 0) && goto(%d) : (write(this/CorrectionErrorFlag) = 1) && goto(%d);Checking correction condition;Error checking correction condition;-1;tangoerror=goto(%d)',cnt,cnt+1,start_step,error_step);

% start sequences
for seq=1:num_sequences
	cnt = cnt + 1;
	blk{cnt}=sprintf('step%d;(((read(this/TargetSelectorMask) & 0x%x) > 0) && (read($devdir_attr%02d$) != 0)) ? (write(this/Direction) = read($devdir_attr%02d$)) && goto(%d) : (write(this/Direction) = 0) && goto(%d);tangoerror=goto(%d)',cnt,2^(seq-1),seq,seq,cnt+num_sequences+2-seq,cnt+1,error_step);
end

% error in the target
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;goto(%d);Checking target selector;Invalid target selector or target fault;-1',cnt,start_step);

% calculate correction 
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;(write(this/CorrectionVal) = (read(this/Direction) * read(this/KickVal))) && (read(this/RandomMode) == 1) ? (write(this/CorrectionVal) = (read(this/CorrectionVal)* $random)) && goto(%d) : goto(%d);Calculating correction kick;Error calculating correction kick;-1;tangoerror=goto(%d)',cnt,cnt+1,cnt+1,error_step);

% apply correction
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;read(this/CorrectionVal) == 0 ? (write(this/DataErrorFlag) = 1) && goto(%d) : (write($devactuator_w_attr) = (read($devactuator_wr_attr) + read(this/CorrectionVal))) && (write(this/DataErrorFlag) = 0) && (write(this/TangoErrorFlag) = 0) && goto(%d);-1;tangoerror=goto(%d)',cnt,start_step,cnt+2,error_step);

% error step
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;(write(this/TangoErrorFlag) = 1) && goto(%d);Setting tango error flag;Error setting Tango error flag;-1',cnt,start_step);

% explore 
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;read(this/ExploreMode) == 1 ? goto(%d) : goto(%d);Check kick mode;Error checking kick mode;-1',cnt,start_step,correction_step);


%
% Dynamic attributes
%
cnt = 0;
cnt = cnt + 1;
footer{cnt} = 'attr;TargetSelectorMask;long;1';
cnt = cnt + 1;
footer{cnt} = 'attr;KickVal;double;1';
cnt = cnt + 1;
footer{cnt} = 'attr;RandomMode;bool;0';
cnt = cnt + 1;
footer{cnt} = 'attr;ExploreMode;bool;0';
cnt = cnt + 1;
footer{cnt} = 'attr;MaxSleepCnt;long;10';
%
% R/o dynamic attributes
%
cnt = cnt + 1;
footer{cnt} = 'attr;RunErrorFlag;bool;0';
cnt = cnt + 1;
footer{cnt} = 'attr;CorrectionErrorFlag;bool;0';
cnt = cnt + 1;
footer{cnt} = 'attr;DataErrorFlag;bool;0';
cnt = cnt + 1;
footer{cnt} = 'attr;TangoErrorFlag;bool;0';
%
% Internal dynamic attributes
%
cnt = cnt + 1;
footer{cnt} = 'attr;ActuatorStartValue;double;0';
cnt = cnt + 1;
footer{cnt} = 'attr;ActuatorCurValue;double;0';
cnt = cnt + 1;
footer{cnt} = 'attr;Direction;double;0';
cnt = cnt + 1;
footer{cnt} = 'attr;CorrectionVal;double;1';
cnt = cnt + 1;
footer{cnt} = 'attr;SleepCnt;long;0';

fileID = fopen(seq_name,'w');
for i=1:size(header,2)
    fprintf(fileID,'%s\n',header{i});
end
for i=1:size(blk,2)
    fprintf(fileID,'%s\n',blk{i});
end
for i=1:size(footer,2)
    fprintf(fileID,'%s\n',footer{i});
end

fclose(fileID);

end

%
% Wildcards
%
% $description=
% $devactuator_rr_attr=
% $devactuator_wr_attr=
% $devactuator_w_attr=
% $condition_run=
% $condition_corr=
% $random=
% $direction01$=
% $direction02$=
% $direction03$=
% $direction04$=
% $direction05$=
% $direction06$=
% $direction07$=
% $direction08$=
% $direction09$=
% $direction10$=
% $sleep_monitor=
